## udoo-web-conf 0.3.1

=== public/ardublockly/package/requirements.txt ===
mkdocs>=0.12.1
py2exe>=0.6.9
