=== public/ardublockly/package/pyinstaller/bootloader/wscript ===
#! /usr/bin/env python
#-----------------------------------------------------------------------------
# Copyright (c) 2013, PyInstaller Development Team.
#
# Distributed under the terms of the GNU General Public License with exception
# for distributing bootloader.
#
# The full license is in the file COPYING.txt, distributed with this software.
#-----------------------------------------------------------------------------


"""
Bootloader building script.
"""


import os
import platform
import sys

# Workaround for Python 2.6. 'sysconfig' is not available in Python 2.6.
try:
    import sysconfig
except ImportError:
    import distutils.sysconfig as sysconfig

import Utils
import Options


# the following two variables are used by the target "waf dist"
VERSION=''
APPNAME=''


# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'


# TODO use following variable only on darwin and for 32bit loader.
# OS X 10.5 doesn't understand the load command  'LC_DYLD_INFO_ONLY'
# that is used by the OS X 10.6 linker.
# The following variable fixes 10.5 compatibility.
os.environ['MACOSX_DEPLOYMENT_TARGET'] = '10.5'


# TODO strip created binaries.


def set_options(opt):
    myplatform = Utils.detect_platform()
    
    if not myplatform.startswith('win'):
        opt.add_option('--leak-detector',
                action = 'store_true',
                help = 'Link with Boehm garbage collector to detect memory leaks.',
                default = False,
                dest = 'boehmgc')

    if myplatform.startswith('linux'):
        opt.add_option('--no-lsb',
                action = 'store_true',
                help = 'Prevent building LSB (Linux Standard Base) bootloader.',
                default = False,
                dest = 'nolsb')
        opt.add_option('--lsbcc-path',
                action = 'store',
                help = 'Path to lsbcc. By default PATH is searched for lsbcc otherwise is tried file /opt/lsb/bin/lsbcc. [Default: lsbcc]',
                default = 'lsbcc',
                dest = 'lsbcc_path')
        opt.add_option('--lsb-target-version',
                action = 'store',
                help = 'Specify LSB target version [Default: 4.0]',
                default = '4.0',
                dest = 'lsb_version')

    opt.tool_options('compiler_cc')


def configure(conf):

    def achitecture():
        return '32bit'

    conf.env.NAME = 'default'

    opt = Options.options
    myplatform = Utils.detect_platform()

    # on 64bit Mac function platform.architecture() returns 64bit even
    # for 32bit Python. This is the workaround for this.
    if myplatform == 'darwin' and sys.maxint <= 3**32:
        myarch = '32bit'
    else:
        myarch = platform.architecture()[0] # 32bit or 64bit
    conf.env.MYARCH = myarch

    # Differenciate path to bootloader with machine name if necessary.
    mymach = platform.machine()
    if mymach.startswith('arm'):
        mymach = 'arm'
    else:
        # Assume x86/x86_64 machine.
        mymach = None
    conf.env.MYMACHINE = mymach


    Utils.pprint('CYAN', '%s-%s detected' % (platform.system(), myarch))

    if myplatform == 'darwin' and myarch == '64bit':
        Utils.pprint('CYAN', 'WARNING: Building bootloader for Python 64-bit on Mac OSX')
        Utils.pprint('CYAN', 'For 32b-bit bootloader prepend the python command with:')
        Utils.pprint('CYAN', 'VERSIONER_PYTHON_PREFER_32_BIT=yes arch -i386 python')

    if myplatform.startswith('linux') and not opt.nolsb:
        Utils.pprint('CYAN', 'Building LSB bootloader.')

    ### C compiler

    if myplatform.startswith('win'):
        try:
            # mingw (gcc for Windows)
            conf.check_tool('gcc')
        except:
            try:
                # Newest detected MSVC version is used by default.
                # msvc 7.1 (Visual Studio 2003)
                # msvc 8.0 (Visual Studio 2005)
                # msvc 9.0 (Visual Studio 2008)
                conf.env['MSVC_VERSIONS'] = ['msvc 7.1', 'msvc 8.0', 'msvc 9.0', 'wsdk 7.0', 'wsdk 7.1']
                if myarch == '32bit':
                    conf.env['MSVC_TARGETS'] = ['x86', 'ia32']
                elif myarch == '64bit':
                    conf.env['MSVC_TARGETS'] = ['x64', 'x86_amd64', 'intel64', 'em64t']
                conf.check_tool('msvc')
                conf.print_all_msvc_detected()
                # Do not embed manifest file.
                # Manifest file will be added in the phase of packaging python application.
                conf.env.MSVC_MANIFEST = False
            except Exception, e:
                print(e)
                Utils.pprint('RED', str(e))
                Utils.pprint('RED', 'GCC (MinGW) or MSVC compiler not found.')
                exit(1)
        else:
            # When using GCC, deactivate declarations after statements
            # (not supported by Visual Studio)
            conf.env.append_value('CCFLAGS', '-Wdeclaration-after-statement')
            conf.env.append_value('CCFLAGS', '-Werror')

    else:
        conf.check_tool('compiler_cc')


    ### build LSB (Linux Standard Base) boot loader
    if myplatform.startswith('linux') and not opt.nolsb:
        try:
            # custom lsbcc path
            if opt.lsbcc_path != 'lsbcc':
                conf.env.LSBCC = conf.find_program(opt.lsbcc_path, mandatory=True)
            # default values
            else:
                conf.env.LSBCC = conf.find_program(opt.lsbcc_path)
                if not conf.env.LSBCC:
                    conf.env.LSBCC = conf.find_program('/opt/lsb/bin/lsbcc',
                            mandatory=True)
        except:
            Utils.pprint('RED', 'LSB (Linux Standard Base) tools >= 4.0 are required.')
            Utils.pprint('RED', 'Try --no-lsb option if not interested in building LSB binary.')
            exit(2)
        # lsbcc as CC compiler
        conf.env.append_value('CCFLAGS', '--lsb-cc=%s' % conf.env.CC[0])
        conf.env.append_value('LINKFLAGS', '--lsb-cc=%s' % conf.env.CC[0])
        conf.env.CC = conf.env.LSBCC
        conf.env.LINK_CC = conf.env.LSBCC
        ## check LSBCC flags
        # --lsb-besteffort - binary will work on platforms without LSB stuff
        # --lsb-besteffort - available in LSB build tools >= 4.0
        conf.check_cc(ccflags='--lsb-besteffort',
                msg='Checking for LSB build tools >= 4.0',
                errmsg='LSB >= 4.0 is required', mandatory=True)
        conf.env.append_value('CCFLAGS', '--lsb-besteffort')
        conf.env.append_value('LINKFLAGS', '--lsb-besteffort')
        # binary compatibility with a specific LSB version
        # LSB 4.0 can generate binaries compatible with 3.0, 3.1, 3.2, 4.0
        # however because of using function 'mkdtemp', loader requires
        # using target version 4.0
        lsb_target_flag = '--lsb-target-version=%s' % opt.lsb_version
        conf.env.append_value('CCFLAGS', lsb_target_flag)
        conf.env.append_value('LINKFLAGS', lsb_target_flag)


    ### Defines, Includes

    if myplatform.startswith('lin'):
        # make sure we don't use declarations after statement (break Visual Studio)
        conf.env.append_value('CCFLAGS', '-Wdeclaration-after-statement')
        conf.env.append_value('CCFLAGS', '-Werror')

    if not myplatform.startswith('win'):
        # Defines common for Unix and Unix-like platforms.
        # For details see:
        #   http://man.he.net/man7/feature_test_macros
        #
        ## Without these definitions compiling maight fail on OSX.
        conf.env.append_value('CCDEFINES', '_POSIX_C_SOURCE=200112L')
        # SUS v2 (UNIX 98) definitions.
        #   Mac OS X 10.5 is UNIX 03 compliant.
        conf.env.append_value('CCDEFINES', '_XOPEN_SOURCE=500')
        conf.env.append_value('CCDEFINES', '_REENTRANT')
        # Function 'mkdtemp' is available only if _BSD_SOURCE is defined.
        conf.env.append_value('CCDEFINES', '_BSD_SOURCE')
        

    if myplatform.startswith('win'):
        conf.env.append_value('CCDEFINES', 'WIN32')
        conf.env.append_value('CPPPATH', '../zlib')

    if myplatform.startswith('sun'):
        conf.env.append_value('CCDEFINES', 'SUNOS')

        if conf.env.CC_NAME == 'gcc':
            # On Solaris using gcc the linker options for shared and static libraries
            # are slightly different from other platforms.
            conf.env['SHLIB_MARKER'] = '-Wl,-Bdynamic'
            conf.env['STLIB_MARKER'] = '-Wl,-Bstatic'

    if myplatform.startswith('aix'):
        conf.env.append_value('CCDEFINES', 'AIX')

        # On AIX some APIs are restricted if _ALL_SOURCE is not defined.
        # In the case of PyInstaller, we need the AIX specific flag RTLD_MEMBER
        # for dlopen() which is used to load a shared object from a library
        # archive. We need to load the Python library like this:
        #  dlopen("libpython2.7.a(libpython2.7.so)", RTLD_MEMBER)
        conf.env.append_value('CCDEFINES', '_ALL_SOURCE')

        if conf.env.CC_NAME == 'gcc':
            # On AIX using gcc the linker options for shared and static libraries
            # are slightly different from other platforms.
            conf.env['SHLIB_MARKER'] = '-Wl,-bdynamic'
            conf.env['STATICLIB_MARKER'] = '-Wl,-bstatic'

    conf.env.append_value('CPPPATH', os.path.join('..', 'common'))


    ### Libraries

    if myplatform.startswith('win'):
        conf.check_cc(lib='user32', mandatory=True)
        conf.check_cc(lib='comctl32', mandatory=True)
        conf.check_cc(lib='kernel32', mandatory=True)
        conf.check_cc(lib='ws2_32', mandatory=True)

    else:
        if not sys.platform.startswith('freebsd'):  # FreeBSD doesn't need libdl
            conf.check_cc(lib='dl', mandatory=True)
        elif sysconfig.get_config_vars('HAVE_PTHREAD_H').pop(): # link to libthr on FreeBSD
            conf.check_cc(lib='thr', mandatory=True)
        conf.check_cc(lib='z', mandatory=True)
        if conf.check_cc(function_name='readlink', header_name='unistd.h'):
            conf.env.append_value('CCFLAGS', '-DHAVE_READLINK')

        # This uses Boehm GC to manage memory - it replaces malloc() / free()
        # functions. Some messages are printed if memory is not deallocated.
        if opt.boehmgc:
            conf.check_cc(lib='gc', mandatory=True)
            conf.env.append_value('CCDEFINES', 'PYI_LEAK_DETECTOR')
            conf.env.append_value('CCDEFINES', 'GC_FIND_LEAK')
            conf.env.append_value('CCDEFINES', 'GC_DEBUG')
            conf.env.append_value('CCDEFINES', 'SAVE_CALL_CHAIN')

    ### ccflags

    if myplatform.startswith('win') and conf.env.CC_NAME == 'gcc':
        # Disables console - MinGW option
        conf.check_cc(ccflags='-mwindows', mandatory=True,
                msg='Checking for flags -mwindows')
        # Use Visual C++ compatible alignment
        conf.check_cc(ccflags='-mms-bitfields', mandatory=True,
                msg='Checking for flags -mms-bitfields')
        conf.env.append_value('CCFLAGS', '-mms-bitfields')

    elif myplatform.startswith('win') and conf.env.CC_NAME == 'msvc':
        if myarch == '32bit':
            conf.env.append_value('LINKFLAGS', '/MACHINE:X86')
        elif myarch == '64bit':
            conf.env.append_value('LINKFLAGS', '/MACHINE:X64')
        # Enable 64bit porting warnings and other warnings too.
        conf.env.append_value('CCFLAGS', '/W3')
        # We use SEH exceptions in winmain.c; make sure they are activated.
        conf.env.append_value('CCFLAGS', '/EHa')
    
    # Compile with 64bit gcc 32bit binaries or vice versa.
    if conf.env.CC_NAME == 'gcc' and platform.machine() != 'sw_64':
        if myarch == '32bit' and conf.check_cc(ccflags='-m32', msg='Checking for flags -m32'):
            conf.env.append_value('CCFLAGS', '-m32')
        elif myarch == '64bit':
            conf.env.append_value('CCFLAGS', '-m64')

    # Ensure proper architecture flags on Mac OS X.
