=== debian/changelog ===
udoo-web-conf (0.3.1-1) trusty; urgency=medium

  * Corrected captions
  * Fixed Tutorial link for QDL

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 21 Jul 2016 13:33:29 +0000

udoo-web-conf (0.3.0-6) trusty; urgency=medium

  * Remove ardublockly shortcut for non-supported platforms

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 07 Apr 2016 12:59:37 +0000

udoo-web-conf (0.3.0-5) trusty; urgency=medium

  * Fixed desktop shortcuts and added images
  * Added /usr/sbin to PATH
  * Building release

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 07 Apr 2016 12:59:37 +0000

udoo-web-conf (0.3.0-3) trusty; urgency=medium

  * Building release

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 24 Mar 2016 14:52:10 +0000

udoo-web-conf (0.3.0-2) trusty; urgency=medium

  [ Francesco Montefoschi ]
  * New UI
  * Improved WiFi selection
  * Added regional settings, password management, video and M4 core selection
  * Integrated Ardublockly

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 17 Mar 2016 16:37:46 +0000

udoo-web-conf (0.2.1-1) trusty; urgency=medium

  * New version, see Vcs log

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Thu, 10 Dec 2015 18:29:01 +0100

udoo-web-conf (0.2.0-1ubuntu1) trusty; urgency=medium

  * New version, see Vcs log

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Wed, 09 Dec 2015 16:15:06 +0100

udoo-web-conf (0.1.0-1ubuntu1) trusty; urgency=medium

  * Updated install scripts

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Tue, 17 Nov 2015 12:22:48 +0100

udoo-web-conf (0.1.0-1) trusty; urgency=low

  * Initial release 

 -- Ettore Chimenti <ek5.chimenti@gmail.com>  Wed, 11 Nov 2015 18:24:48 +0100
