=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/udoo-web-conf-$1\.tar\.gz/ \
  https://github.com/UDOOboard/udoo-web-conf/tags .*/v?(\d\S*)\.tar\.gz
